﻿var iTunesApp = null;

//var darkgray = "#444444";
//var blue = "#0000FF";

var last = null;


function view_onOpen()
{
	clearGui();
	song.innerText = "";
	album.innerText = "";
	artist.innerText = "";

	if(isRunning() == true) runItunes();
	else askToRun();
	
	return;

	
}
function isRunning(){
	var processlist = framework.system.process.enumerateProcesses;
	for(i = 0; i<processlist.Count; i++){

		var pid = processlist.Item(i);

		var procinfo = framework.system.process.getInfo(pid);
		var pathOfProc = procinfo.executablePath;
		
		var init = pathOfProc.indexOf("itunes.exe");
		if (init != -1){
			return true;
		}
	}
	return false;
}

// ask user to run iTunes when iTunes is not running.
function askToRun(){
	clearGui();
	if(isRunning()){
		song.innerText = "iTunes is shutting down";
		view.setTimeout("askToRun()", 500);
		return
	}

	song.innerText = "iTunes is not running.";
	golnk.visible = true;
	return;
}

function clearGui(){
	song.innerText = "";
	artist.innerText = "";
	album.innerText = "";
	golnk.visible = false;

	artimg.src = null;
	artimg.visible = false;
	
	playbtn.visible = false;
	prevbtn.visible = false;
	nextbtn.visible = false;
	rewindbtn.visible = false;
	fwdbtn.visible = false;
	itunesbtn.visible = false;

	last = null;
	return;
}

function showMusicGui(){
	song.innerText = "";
	golnk.visible = false;
	artimg.src = null;
	artimg.visible = true;;
	
	playbtn.visible = true;
	prevbtn.visible = true;
	nextbtn.visible = true;
	rewindbtn.visible = true;
	fwdbtn.visible = true;
	itunesbtn.visible = true;
}

function runItunes(){
	song.innerText = "Starting iTunes ...";
	golnk.visible = false;
	try{
		var wshShell = new ActiveXObject("WScript.Shell");
		wshShell.run("itunes");
	
		connecttoken = view.setTimeout("connect()", 1000);
	}catch(e){
		couldnotconnect();
	}
	return;
}


function connect(){
	if(isRunning() == false) {
		couldnotconnect();
		return;
	}
	try{
		//hangs system when itunes has to start up
		tryingtoconnect = true;
		iTunesApp = new ActiveXObject("iTunes.Application");
	}catch(e){
		couldnotconnect();
		return;
	}
	if(iTunesApp == null){
		couldnotconnect();
		return;
	}
	showMusicGui();
	update();
	updateloopid = view.setInterval("update()", 300);
	return;
}


var updateloopid = null;

function couldnotconnect(){
		cancelUpdate();
		clearGui();
		song.innerText = "Could not connect to iTunes";
		golnk.visible = true;
		return;
}
function cancelUpdate(){
	if (updateloopid != null){
		view.clearInterval(updateloopid);
		updateloopid = null;
	}
}


function update(){
	
try{
	if (iTunesApp == null){
		cancelUpdate();
		askToRun();
		return;
	}

	var curr = iTunesApp.CurrentTrack;
	var state = iTunesApp.PlayerState;
	//new btns
	 if (state == 1) {
		playbtn.image = "stock_images\\pause_normal.png";
		playbtn.overImage = "stock_images\\pause_over.png";
		playbtn.downImage = "stock_images\\pause_normal.png";
	 }
	 else {
		playbtn.image = "stock_images\\play_normal.png";
		playbtn.overImage = "stock_images\\play_over.png";
		playbtn.downImage =  "stock_images\\play_normal.png";
	}


	//new btns
	 if (state == 0) {
		fwdbtn.enabled = false;
		rewindbtn.enabled = false;
	 }else{
		fwdbtn.enabled = true;
		rewindbtn.enabled = true;
	}
	

	if(curr != null){
		song.innerText = curr.Name;
		artist.innerText = curr.Artist;
		album.innerText = curr.Album;

		var artlist = curr.Artwork;
		

		var artitem = artlist.Item(1);

		if(last == null) showart(artitem);
		else if (curr.album != last.album) showart(artitem);
		
		
		
		
	}else{
		song.innerText = "Push play to start";

		artist.innerText = "";
		album.innerText = "";
		playbtn.image = "stock_images\\play_normal.png";
		playbtn.overImage = "stock_images\\play_over.png";
		playbtn.downImage =  "stock_images\\play_normal.png";
		
		showart(null);
	}
	last = curr;
	return; 
}  
catch(e){
	cancelUpdate();
	itunesApp = null;
	askToRun();
} 
}

function playpause()
{
 var state = iTunesApp.PlayerState;
 if (state == 0) iTunesApp.Play()
 else if (state == 1) iTunesApp.Pause()
 else iTunesApp.Resume();

 update();
 return;
}

function next(){
	 iTunesApp.NextTrack();
	 update();
}
function prev(){
	 iTunesApp.BackTrack();
	 update();
}


function rewind(){
	 var state = iTunesApp.PlayerState;
	 if (state == 0) return;
	 else if (state == 1 || state == 2) iTunesApp.Rewind();
	 else if (state == 3) iTunesApp.Resume();
	 update();
}

function forward(){
	 var state = iTunesApp.PlayerState;
	 if (state == 0) return;
	 else if (state == 1 || state == 3) iTunesApp.FastForward();
	 else if (state == 2) iTunesApp.Resume();
	 update();
}

function resize(){
	var w = view.width;
	var h = view.height;


	if(w < 190) artimg.visible = false;
	else if(artimg.src != null) artimg.visible = true;
	else artimg.visible = false;

	if(artimg.visible){
	artimg.x = w - 69;
	song.width = w - 80;
	artist.width = w - 80;
	album.width = w - 80;}
	else{
		song.width = w - 10;	
		artist.width = w - 10;
		album.width = w - 10;
	}
}

//shows art when artitem is not null
//hides art image when artitem is null.
function showart(artitem){

	var h = view.height;
	var w = view.width;

	if(artitem == null) {
		artimg.visible = false;
		artimg.src = null;
	}
	else{
		artimg.visible = true;
		artitem.SaveArtworkToFile("c:\\art.tmp");
		artimg.src = "c:\\art.tmp";
		
	}
	resize();
}

function itunesctrl(){
	var windowslist = iTunesApp.Windows;
	
	var itunes = windowslist.ItemByName("iTunes");

	itunes.Minimized = !itunes.Minimized;

}

function sidewindow(){

}
